:- multifile aspect_/2.

/**
* Anything that you want to weave into must be declared as dynamic/1.
* 
* Definition of aspects is by using aspect_/2. 
* A simple sample, weaving two advices (before, after) into the predicate uses(m,m, _,_):
*
* aspect_(group_name, no_unification_after_method_uses_method) :-
*   PC_method_uses_method = uses(method, method, M, C),
*   before_advice(PC_method_uses_method, print('abc')),
*   after_advice(PC_method_uses_method, not(M == C)).
*
* To weave into your own predicates, the last call in your
* top-level load.pl should be:
*
* :- call(weave_aspect(group_name, Name)).
*/

weave_aspect(Module, Name) :-
    aspect_(Module, Name).
    
    