:- module( cultivate_basic_caching, [
										clear_query_cache/1  % can have additional clauses elsewhere but is defined here
			 						]).

:- reexport( [ cached_smell, 
			   cached_metric, 
			   cached_relationmetric,
			   cached_relationsmell,
			   internal_cache 
			 ]). 				 


% Defines  helper predicate for clearing dynamic predicates in a modules
:- use_module(clear_caching).



%:- multifile clear_query_cache/1.

/** clear_query_cache(?Definition) is det
*
* retracts query facts, this is called via java for cleanup
* It presents a hooking mechanism for cleanup if the JTransformer factbase is invalidated 
*/
:- multifile clear_query_cache/1.
% retracts all dynamic predicates in the used modules
clear_query_cache(smells_and_metrics) :-
    clear_cache(cultivate_basic_smells),
    clear_cache(cultivate_basic_metrics),
    clear_cache(cultivate_basic_relationmetrics),
    clear_cache(cultivate_basic_relationsmells),
    clear_cache(cultivate_basic_caching_internal).
    
    