/**
* overrides(?MethodID, ?SuperMethodID)
*
* Returns true if Method overrides SuperMethod, else false.
* Method is overriding method, SuperMethod is overridden method.
* If no IDs are given, a pair of overriding and overriden method IDs will be returned.
*/
overrides(MethodID, SuperMethodID) :-
    methodDef(MethodID, ClassID, _, _, _, _, _),
    not(constructor(MethodID)),
    not(is_static(MethodID)),
    real_subtype(ClassID, SuperClassID),
    type_contains_method(SuperClassID,SuperMethodID),
    not(is_static(SuperMethodID)),
    not(method_modifier(SuperMethodID, final)),
    same_signature(MethodID, SuperMethodID),
    can_access_method(ClassID, SuperMethodID).



    
/**
* overrides(?MethodID, ?SuperType, ?SuperMethodID)
*
* Returns true if Method overrides SuperMethod in SuperType, else false.
* Method is overriding method, SuperMethod is overridden method.
*/
%% TODO 2010-10-22 jn: merge with above

overrides(MethodID, SuperType, SuperMethodID) :-
    methodDef(MethodID, ClassID, _, _, _, _, _),
    not(constructor(MethodID)),
    not(is_static(MethodID)),
    real_subtype(ClassID, SuperType),
    type_contains_method(SuperType,SuperMethodID),
    not(is_static(SuperMethodID)),
    not(method_modifier(SuperMethodID, final)),
    same_signature(MethodID, SuperMethodID),
    can_access_method(ClassID, SuperMethodID),
    !. % can_access_method resolves implicitly derived visibilities -> multiple results

