/**
* parameter_difference(+List1, +List2, -List3)
*
* Computes the difference of List1 and List2.
* Lis3 is List1\List2.
*/
parameter_difference(Elem, [], Elem) :- !.

parameter_difference([Head|Tail], Subset, Diff) :-
    paramT(Head, _, Type, Name),
    member(ParamID, Subset),
    paramT(ParamID, _, Type, Name),
    select(ParamID, Subset, Rest_Subset),
    parameter_difference(Tail, Rest_Subset, Diff), !.

parameter_difference([Head|Tail], Subset, Diff) :-
    paramT(Head, _, Type, Name),
    member(ParamID, Subset),
    not(paramT(ParamID, _, Type, Name)),
    parameter_difference(Tail, Subset, Sub_Diff),
    append([Head], Sub_Diff, Diff), !.

