/**
* parameter_type(?ParameterID, ?TypeTerm)
*
* Maps parameter id and TypeTerm.
* Gets matching parameter id and TypeTerm (eg. type(basic, int, 0)).
*/
parameter_type(ParameterID, TypeTerm) :-
    paramT(ParameterID, _, TypeTerm, _).

/**
* parameter_type_name(?ParameterID, ?TypeName)
*
* Maps parameter id and parameter type name (eg. String).
*/
parameter_type_name(ParameterID, TypeName) :-
    paramT(ParameterID, _, TypeTerm, _),
    type_term_nqn(TypeTerm, TypeName), !.


/**
* parameter_types(+Parameters,-ListOfParameterTypes)
* succeeds if Arg1 is the list representing the types from the parameter IDs in Arg1
*/
parameter_types(Parameters,ListOfParameterTypes):-   
				maplist(parameter_type_name,Parameters,ListOfParameterTypes).