/*
* same_signature(+MethodID, +AnotherMethodID)
*
* Returns true if both methods have the same name, the same number of parameters and the same
* parameter types (same order).
* If no MethodID is given, the IDs of two methods with the same signature will be returned.
*/
same_signature(MethodID, AnotherMethodID) :-
    methodT(MethodID, _, MethodName, Parameters, _, _, _),
    methodT(AnotherMethodID, _, MethodName, MoreParameters, _, _, _),
    not( MethodID = AnotherMethodID ),
    equal_parameter_types(Parameters, MoreParameters).

same_signature(MethodID, AnotherMethodID) :-
    constructorT(MethodID,_,Parameters,_,_),
    constructorT(AnotherMethodID,_,MoreParameters,_,_),
    not( MethodID = AnotherMethodID ),
    equal_parameter_types(Parameters, MoreParameters).





