:- multifile get_graph_/4.

get_graph_(lcom3,adjazenzlist,ClassId,Graph):-
    lcom3_adjazenz_list__(ClassId,AGraph),   
    Graph = [[['metric','lcom4'],['type','adjazenzlist']],AGraph].
    
get_graph_(lcom3,undirected,ClassId,Graph):-
    normal_class(ClassId),
    all_normal_methods_of_class(ClassId,Nodes),           
    methodpairs_ref_to_same_field_list(undirected,ClassId,UnsortedPairs),
    sort(UnsortedPairs,Edges),
    Graph = [[['metric','lcom4'],['type','undirected']],[Nodes,Edges]].
    
get_graph_(lcom3,undirected-named,ClassId,Graph):-
    get_graph_(lcom3,undirected,ClassId,UdirGraph),
    udir_graph_to_named_udir_graph(UdirGraph,Graph).

lcom3_adjazenz_list__(ClassId,AdjazenzList):-
    normal_class(ClassId),
    lcom3_dir_graph__(ClassId,MethodsOfClass,Edges),
    dir_graph_to_adjazenzlist_internal([MethodsOfClass,Edges],AdjazenzList).

lcom3_dir_graph__(ClassId,MethodsOfClass,Edges):-
	all_normal_methods_of_class(ClassId,MethodsOfClass),           
    methodpairs_ref_to_same_field_list(directed,ClassId,UnsortedPairs),
    sort(UnsortedPairs,Edges).
