/**
 * name_of_element(+Id,?Name)
 * Succeeds iff Name is the corresponding Java name for Id.
 *
 */
name_of_element(Context, Name) :- identifier_declaration_or_reference(Context,Name).


/**
*
*
*/
identifier_declaration_or_reference(Id, Name) :-
   declared_identifier(Id, Name)  ; 
   referenced_identifier(Id, Name).
   

/**
 * declared_identifier(+Declaration, ?Identifier)
 * succeeds iff Arg1 is the ID of the name Arg2,  
 *     Arg1 can be package,type,method, param, field, local 
 */
declared_identifier(Declaration, Identifier) :- packageT(Declaration, Identifier). 

declared_identifier(Declaration, Identifier) :- classT(Declaration, _, Identifier, _).

declared_identifier(Declaration, Identifier) :- methodT(Declaration, _, Identifier, _, _, _, _).


declared_identifier(Declaration, Identifier) :- paramT(Declaration, _, _, Identifier).

declared_identifier(Declaration, Identifier) :- fieldT(Declaration, _, _, Identifier, _).

declared_identifier(Declaration, Identifier) :- localT(Declaration,_,_,_,Identifier, _).
    
/**
 * referenced_identifier(+Expression, ?Identifier)
 * succeeds if Arg1 is the ID of the references identifier Arg2 
 */
referenced_identifier(Expression, Identifier) :-
    callT(Expression, _, _, _, Identifier, _, _).
    
referenced_identifier(Expression, Identifier) :-    
    getFieldT(Expression, _,_,_, Identifier, _).

referenced_identifier(Expression, Identifier) :-    
    identT(Expression, _, _, Identifier, _).
