:- multifile query_description/3.
:- multifile smell_/2.

query_description(misnamedTestclassDetector,smell,'test class with invalid name').

  
smell_(misnamedTestclassDetector,ClassID) :-
    internal_package(PackageID),
    package_contains_type(PackageID,ClassID),
    check_for_misnamed_testclass__(ClassID).
    
    

/**
        check_for_misnamed_testclass(+ClassID)
        
        This predicate will return true, if the "ClassID"
        is a testCase and has a non conventional name
*/
check_for_misnamed_testclass__(ClassID) :-
        test_class(ClassID),
        classT(ClassID,_,Name,_),
        not(atom_concat(_,'Test',Name)).