/**
* statement(+StatementId, ?ParentId, ?EnclosingId)
* generic access to statements with parent and enclosing nodes
* no blockT
*/
statement(StatementId, ParentId, EnclosingId) :-
    assertT(StatementId, ParentId, EnclosingId, _, _).

statement(StatementId, ParentId, EnclosingId) :-
	breakT(StatementId, ParentId, EnclosingId, _, _).
	
statement(StatementId, ParentId, EnclosingId) :-
	caseT(StatementId, ParentId, EnclosingId, _).
	
statement(StatementId, ParentId, EnclosingId) :-
	catchT(StatementId, ParentId, EnclosingId, _, _).
	
statement(StatementId, ParentId, EnclosingId) :-
	continueT(StatementId, ParentId, EnclosingId, _, _).
	
statement(StatementId, ParentId, EnclosingId) :-
	doWhileT(StatementId, ParentId, EnclosingId, _, _).
	
statement(StatementId, ParentId, EnclosingId) :-
	execT(StatementId, ParentId, EnclosingId, _).
	
statement(StatementId, ParentId, EnclosingId) :-
	forT(StatementId, ParentId, EnclosingId, _, _, _, _).
	
statement(StatementId, ParentId, EnclosingId) :-
	foreachT(StatementId, ParentId, EnclosingId, _, _, _).
		
statement(StatementId, ParentId, EnclosingId) :-
	ifT(StatementId, ParentId, EnclosingId, _, _, _).
	
statement(StatementId, ParentId, EnclosingId) :-
	labelT(StatementId, ParentId, EnclosingId, _, _).
								    
statement(StatementId, ParentId, EnclosingId) :-
	localT(StatementId, ParentId, EnclosingId, _, _, _).

statement(StatementId, ParentId, EnclosingId) :-
	nopT(StatementId, ParentId, EnclosingId).
	
statement(StatementId, ParentId, EnclosingId) :-
	returnT(StatementId, ParentId, EnclosingId, _).
	
statement(StatementId, ParentId, EnclosingId) :-
	switchT(StatementId, ParentId, EnclosingId, _, _).
	
statement(StatementId, ParentId, EnclosingId) :-
	synchronizedT(StatementId, ParentId, EnclosingId, _, _).
	
statement(StatementId, ParentId, EnclosingId) :-
	throwT(StatementId, ParentId, EnclosingId, _).
	
statement(StatementId, ParentId, EnclosingId) :-
	tryT(StatementId, ParentId, EnclosingId, _, _, _).
			
statement(StatementId, ParentId, EnclosingId) :-
	whileT(StatementId, ParentId, EnclosingId, _, _).
