/**
* can_access_method(+ClassID, +MethodID)
*
* Returns true if class can access method, else false.
*/
%class contains method
can_access_method(ClassID, MethodID) :-
    methodDef(MethodID, ClassID, _, _, _, _, _).

%public methods 
can_access_method(ClassID, MethodID) :-
    ground([ClassID, MethodID]),
    visibility(MethodID, public),
    methodDef(MethodID, OwnerClassID, _, _, _, _, _),
    can_access_class(ClassID, OwnerClassID).

%protectd methods (subclasses or same package)
can_access_method(ClassID, MethodID) :-
    ground([ClassID, MethodID]),
    visibility(MethodID, protected),
    methodDef(MethodID, OwnerClassID, _, _, _, _, _),
    not(real_subtype(ClassID, OwnerClassID)),
    same_package(ClassID, OwnerClassID),
    can_access_class(ClassID, OwnerClassID).

%protected metods (subclasses)
can_access_method(ClassID, MethodID) :-
    ground([ClassID, MethodID]),
    visibility(MethodID, protected),
    methodDef(MethodID, OwnerClassID, _, _, _, _, _),
    real_subtype(ClassID, OwnerClassID).

%package methods 
can_access_method(ClassID, MethodID) :-
    ground([ClassID, MethodID]),
    visibility(MethodID, package),
    methodDef(MethodID, OwnerClassID, _, _, _, _, _),
    same_package(ClassID, OwnerClassID),
    can_access_class(ClassID, OwnerClassID).

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%WRAPPER%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
/**
* can_access_method(+ClassName, +MethodSignature)
*
* wrapper for can_access_method/2.
*/

/**
* @deprecated
*/
/*
can_access_method(ClassName, MethodSignature) :-
    method_id(MethodSignature, MethodID),
    classT(ClassID, _, ClassName, _),
    can_access_method(ClassID, MethodID).
can_access_method(ClassName, OwnerClass, MethodName, Parameters) :-
    ground([ClassName, OwnerClass, MethodName, Parameters]),
    method_id(method_signature(OwnerClass, MethodName, Parameters), MethodID),
    classT(ClassID, _, ClassName, _),
    can_access_method(ClassID, MethodID).
*/
