%%% joiner(?Type)
%% succeeds iff Type is an empty interface joining two or more superinterfaces.
%%
%% An empty interface which extends more than one interface
%% is called a Joiner, since in effect, it joins together the sets of
%% members of its parents.
%% An empty class which implements one or more interfaces is also
%% a Joiner.
joiner(Interface):-
    classT(Interface,_,_,_),
   	is_interface(Interface),
    not(type_contains_method(Interface,_)),
    once(( 
    	implementsT(Interface,SuperInterface),
    	implementsT(Interface,OtherSuperInterface),
    	not( SuperInterface == OtherSuperInterface )
    )).
    
joiner(Class) :-
    classT(Class,_,_,_),
    not(is_interface(Class)),
    not(type_contains_method(Class,_)),
    once((
    	implementsT(Class,SuperInterface),
    	implementsT(Class,OtherSuperInterface),
    	not( SuperInterface == OtherSuperInterface )
	)).
    