%%%  implementor(?Type)
%% succeeds iff Type is a concrete class, where all the methods override inherited abstract methods.
%%
%% An Implementor is a non-abstract class such that
%% all of its the public methods were declared as abstract in its superclass.
implementor(Type):-
    classT(Type,_,_,_),
    not(modifierT(Type, abstract)),
    extendsT(Type,SuperType),
    once( 	(type_contains_method(Type,AMethod),
    	 	 visibility(AMethod,public))
    	 ),
    forall( 
    		( type_contains_method(Type,Method),
    	 		visibility(Method,public)
    	 	 ),(
    	 		overrides(Method, SuperType, SuperMethod),
				modifierT(SuperMethod,abstract)
			 )).
    