
:- module( cultivate_concepts_micropatterns, [
			micropattern/2
   ] ).

:- use_module(micropatterns).

%%% Micro Patterns
%%% Y. Gil and I. Maman. Micro patterns in Java code. In OOPSLA,pages 97116, 2005.

%%  micropattern(+Name,?ID)
micropattern(Name,ID):-
    ground(Name),
    Predicate =.. [Name, ID],
    call(micropatterns:Predicate).
%% --> defined_in_module(micropatterns,A)  liefer alle prdikate definiert im micropatterns modul

micropattern(Name,ID):-
    not(ground(Name)),
    declared_in_module(micropatterns,B),
    micropatterns:current_predicate(Name,B),
    term_variables(B,[ID]),
    call(micropatterns:B).
    