:- module('cultivate_concepts_termcreation', [ 
												fill_term_cache/0,
												no_cache_available/0,
												cache_available/0,
												term/1,
												is_term_introduced/3,
												report_total_term_statistics/0,
												clear_term_cache/0 
											 ]).
:- use_module(tokenization).
:- use_module(normalization).
:- use_module(bag_of_words_computation).
:- use_module(term_model).
:- use_module(introduction).

%:- use_module(term_occurrence_computation).

fill_term_cache :-                 % 8,818,103 inferences, 4.234 CPU in 4.328 seconds (98% CPU, 2082504 Lips)
  create_term_cache,               %old: 11,855,282 inferences, 3.766 CPU in 3.803 seconds (99% CPU, 3148291 Lips)
                                   %new: 7,448,974 inferences, 2.375 CPU in 2.391 seconds (99% CPU, 3136410 Lips)
  apply_term_normalization, 
  %build_reverse_indices,       
  generate_term_introduced(_),     % 3,522,495 inferences, 0.641 CPU in 0.634 seconds (101% CPU, 5498529 Lips)           
  generate_occurrence_counters,    % 1,344,464 inferences, 1.188 CPU in 1.206 seconds (98% CPU, 1132180 Lips)
  %report_total_statistics.
  true.

report_total_term_statistics :-
    cultivate_concepts_terms:report_statistics,
    cultivate_concepts_term_introduction:report_statistics,
    term_occurrence_computation:report_statistics.
    