:- module('cultivate_concepts_term_util',[ 
				assert_unique/1,
				report_statistics/0,
				dynamic_local_predicate/1,
				clear_local_facts/0,
				cv_number_of_clauses/2
				]). 

                  
      
:- module_transparent assert_unique/1.   
assert_unique(Fact) :- 
   once(Fact) -> true ; assert(Fact).      
      





:- module_transparent report_statistics/0.
report_statistics :-
   forall( 
     dynamic_local_predicate(Head),
     ( functor(Head,Functor,Arity),
       count(Head,Count),
       format('~a  term cache entries for ~w.~n', [Count,Functor/Arity])
     ) 
   ).


:- module_transparent dynamic_local_predicate/1.

dynamic_local_predicate(Head) :-
   context_module(Module),
   declared_in_module(Module, Head),
   predicate_property(Module:Head, dynamic).
       
       
:- module_transparent clear_local_facts/0.
clear_local_facts:-
   forall( 
     dynamic_local_predicate(Head), 
     retractall(Head) 
   ). 
   
 :- module_transparent cv_number_of_clauses/2.  
cv_number_of_clauses(F/A,N) :-
	(   current_predicate(F/A)
	->  functor(G,F,A),
	    findall(1, G, Ts),
	    length(Ts, N)
	;   N = 0
	).        
	
	

	 