/** improvedAbstractness/2
  +PackageID
  ?ReturnValue
  
  computes an improved abstractness for a package.
  based on the depth of inheritence of the contained type and a mapping to an abstractness value. 
*/
improvedAbstractness(PackageID, ReturnValue) :-
    findall(DIT, 
           (package_contains_type(PackageID, ClassID), modifiedDitWithExceptionOfStaticMainMethodClasses(ClassID, DIT)),
    	   List),       
    	   
    sumall(List,Sum),
    length(List, NumberOfTypes),
    depthOfInterheritanceAsAbstractness((Sum / NumberOfTypes), ReturnValue).


modifiedDitWithExceptionOfStaticMainMethodClasses(ClassID, DIT) :-
    type_contains_method(ClassID, MethodID),
	methodDef(MethodID, ClassID, 'main', [Param], type(basic, void, 0), _, _),
	modifierT(MethodID, static),
	modifierT(MethodID, public),
	globalFqn('java.lang.String',StringId),
	paramT(Param, MethodID, type(class, StringId, 1), _),
	pureConcreteDIT(DIT), 
	!.
    
modifiedDitWithExceptionOfStaticMainMethodClasses(ClassID, DIT) :-
    metric(dit, ClassID, DIT).
