/**
* AHH - average hierarchy height
*  is averagen HIT (height of the inheritance tree) 
*	of all user defined root classes, that means from root to deepest subclass, 
*	devided by all user defined root classes.
* Root Class is any standalone class or class with an external supertype
*/
average_hierarchy_height(AHH) :-
    findall(HIT,
    		(user_defined_root_class__(Class),
    		max_height_of_inheritance_tree(Class, HIT)),
  		  AllHits),
  		  
  	sumall(AllHits, TotalHit),
  		  
    count(Class,
    		(user_defined_root_class__(Class)),
    	  NumberOfRootClasses),
   	(NumberOfRootClasses > 0, AHH is TotalHit / NumberOfRootClasses; AHH is 0).
    
    
user_defined_root_class__(Class) :-
    named_internal_type(Class),
  	not(interface(Class)),
  	extendsRecursive(Class, Super),
  	externT(Super).